<template>
  <b-modal
    id="aimsAfterStoreModal"
    v-model="isOpen"
    :title="$t('aims.afterStoreModalTitle')"
    :cancel-title="$t('Cancel')"
    :ok-only="true"
    :ok-title="$t('Continue')"
    @ok="save"
    @cancel="close"
    @close="close"
    @hidden="hidden"
  >
    {{ $t("aims.afterStoreModalDescription") }}
    <b-input-group class="mt-2">
      <b-form-input
        id="accessToken"
        :state="copied ? true : null"
        :disabled="true"
        :model-value="lastAccessTokenUrl"
        trim
      />

      <template #append>
        <b-button variant="outline-secondary" @click="copyToClipboard">
          <i-bi-clipboard />
        </b-button>
        <b-button
          :href="lastAccessTokenUrl"
          target="_blank"
          variant="outline-secondary"
        >
          <i-bi-link45deg />
        </b-button>
      </template>
    </b-input-group>
  </b-modal>
</template>

<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  name: "AimsAfterStoreModal",
  props: {
    lastAccessTokenUrl: {
      required: true,
      default: () => "",
      type: String,
    },
    open: {
      required: true,
      default: () => false,
      type: Boolean,
    },
  },
  data() {
    return {
      copied: false,
      isOpen: false,
    };
  },
  watch: {
    open() {
      this.isOpen = this.open;
    },
  },
  mounted() {
    this.copied = false;
  },
  methods: {
    close() {
      this.isOpen = false;
    },
    async copyToClipboard() {
      await navigator.clipboard.writeText(this.lastAccessTokenUrl);
      this.copied = true;
    },
    hidden() {
      this.$emit("close");
    },
    save() {
      this.$emit("save");
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
